/*
 * Show a screenful of helpful tips.
 *
 * Author: Julian Stecklina <jsteckli@os.inf.tu-dresden.de>
 *
 * TU Dresden, Operating Systems Group
 *
 * Vancouver.nova is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * Vancouver.nova is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details.
 */
#include <sys/console.h>
#include <vmm/motherboard.h>
#include <sigma0/sigma0.h>
#include <cstdint>

void print_screen1(uint16_t *dst);

class Tutor : public NovaProgram,
	      public ProgramConsole
{
  const char *debug_getname() { return "Tutor"; };

public:
  static void exit(unsigned long status)
  {
    Logging::printf("%s(%lx)\n", __func__, status);
  }

  void run(Hip *hip)
  {
    console_init("TUT");

    init(hip);

    print_screen1(_console_data.screen_address);

    block_forever();

  }
};

ASMFUNCS(Tutor);

// EOF
